/*
 * Segment.h
 *
 *  Created on: 2010.09.09.
 *      Author: Karma
 */

#ifndef SEGMENT_H_
#define SEGMENT_H_

#include <FGraphics.h>
#include <FUi.h>

class Segment :
	public Osp::Ui::Controls::Panel,
	public Osp::Ui::ITouchEventListener
{
public:
	enum SegmentPosition
	{
		SEGMENT_MIDDLE = 0x00,
		SEGMENT_LEFT = 0x01,
		SEGMENT_RIGHT = 0x02,
		SEGMENT_ONLY = 0x03
	};

public:
	static void PreloadBitmaps();
	Segment(Osp::Ui::IActionEventListener &listener);
	virtual ~Segment();
	result Construct(const Osp::Base::String &caption, int actionId);

public:
	int GetActionId();
	void SetSelectedState(bool selected);
	void SetPositionId(int positionId);

private:
	result OnDraw();

private:
	static Osp::Graphics::Bitmap *GetBitmap(int id);

private:
	void OnTouchDoublePressed(const Osp::Ui::Control &source, const Osp::Graphics::Point &currentPosition, const Osp::Ui::TouchEventInfo &touchInfo);
	void OnTouchFocusIn(const Osp::Ui::Control &source, const Osp::Graphics::Point &currentPosition, const Osp::Ui::TouchEventInfo &touchInfo);
	void OnTouchFocusOut(const Osp::Ui::Control &source, const Osp::Graphics::Point &currentPosition, const Osp::Ui::TouchEventInfo &touchInfo);
	void OnTouchLongPressed(const Osp::Ui::Control &source, const Osp::Graphics::Point &currentPosition, const Osp::Ui::TouchEventInfo &touchInfo);
	void OnTouchMoved(const Osp::Ui::Control &source, const Osp::Graphics::Point &currentPosition, const Osp::Ui::TouchEventInfo &touchInfo);
	void OnTouchPressed(const Osp::Ui::Control &source, const Osp::Graphics::Point &currentPosition, const Osp::Ui::TouchEventInfo &touchInfo);
	void OnTouchReleased(const Osp::Ui::Control &source, const Osp::Graphics::Point &currentPosition, const Osp::Ui::TouchEventInfo &touchInfo);

private:
	Osp::Ui::IActionEventListener &__listener;
	Osp::Graphics::EnrichedText *__caption;
	Osp::Graphics::TextElement *__captionElement;
	int __position;
	bool __selected;
	int __actionId;

	static Osp::Graphics::Bitmap *__backgrounds[];
};

#endif /* SEGMENT_H_ */
