/*
 * SegmentedControl.h
 *
 *  Created on: 2010.09.09.
 *      Author: Karma
 */

#ifndef SEGMENTEDCONTROL_H_
#define SEGMENTEDCONTROL_H_

#include <FGraphics.h>
#include <FUi.h>

class Segment;
class SegmentedControl :
	public Osp::Ui::Controls::Panel,
	public Osp::Ui::IActionEventListener
{
public:
	static void PreloadBitmaps();

	SegmentedControl();
	virtual ~SegmentedControl();
	result Construct(const Osp::Graphics::Rectangle &bounds);

public:
	result AddSegment(const Osp::Base::String &caption, int actionId);
	result SetSelectedSegmentById(int actionId);
	int GetSelectedSegmentId();
	result SetSelectedSegmentByIndex(int index);
	int GetSelectedSegmentIndex();

public:
	void AddActionEventListener(Osp::Ui::IActionEventListener &listener);
	void RemoveActionEventListener(Osp::Ui::IActionEventListener &listener);

private:
	result OnDraw();
	void OnActionPerformed (const Osp::Ui::Control &source, int actionId);

private:
	void LayoutSegments();
	static Osp::Graphics::Bitmap *GetBackgroundBitmap();

private:
	Osp::Base::Collection::ArrayListT<Osp::Ui::IActionEventListener *> __listeners;
	Osp::Base::Collection::HashMapT<int, Segment *> __segmentsById;
	Osp::Base::Collection::ArrayList __segmentsByIndex;
	int __selectedSegmentId;
	int __selectedSegmentIndex;
	Osp::Graphics::Canvas *__canvas;
	static Osp::Graphics::Bitmap *__bg;
};

#endif /* SEGMENTEDCONTROL_H_ */
